# Flask-RESTful

Flask-RESTful is an extension for Flask that adds support for quickly building REST APIs. It is a lightweight abstraction that works with your existing ORM/libraries. Flask-RESTful encourages best practices with minimal setup. If you are familiar with Flask, Flask-RESTful should be easy to pick up.

## User’s Guide

This part of the documentation will show you how to get started in using Flask-RESTful with Flask.

- Installation
- Quickstart
  - A Minimal API
  - Resourceful Routing
  - Endpoints
  - Argument Parsing
  - Data Formatting
  - Full Example
- Request Parsing
  - Basic Arguments
  - Required Arguments
  - Multiple Values & Lists
  - Other Destinations
  - Argument Locations
  - Multiple Locations
  - Parser Inheritance
  - Error Handling
  - Error Messages
- Output Fields
  - Basic Usage
  - Renaming Attributes
  - Default Values
  - Custom Fields & Multiple Values
  - Url & Other Concrete Fields
  - Complex Structures
  - List Field
  - Advanced : Nested Field
- Extending Flask-RESTful
  - Content Negotiation
  - Custom Fields & Inputs
  - Response Formats
  - Resource Method Decorators
  - Custom Error Handlers
- Intermediate Usage
  - Project Structure
  - Use With Blueprints
  - Full Parameter Parsing Example
  - Passing Constructor Parameters Into Resources

## API Reference

If you are looking for information on a specific function, class or method, this part of the documentation is for you.

- API Docs
  - `marshal()`
  - `marshal_with()`
  - `marshal_with_field()`
  - `abort()`
  - Api
  - ReqParse
  - Fields
  - Inputs

## Additional Notes

See Flask’s license for legal information governing this project.

- Running the Tests